function part2(action)
%PART2 Internally used by FINDEMO.

% Copyright (c) 1996-98 by Rafal Weron.
% Written by: J. Glowinski, R. Weron.
 
global FIGURE COLOR LENGTH OLD OLD2 LINE POSITION L R V MIN MAX TYPE;
 
if nargin==0
  action='init';
  set(FIGURE(5),'visible','off');
  LENGTH=3;
  OLD=[];
  OLD2=[10 10 490 510 1];
end
 
if strcmp(action,'init')
  FIGURE=switch(FIGURE,1);
  pos=get(FIGURE(1),'position');
  set(FIGURE(1),'resize','off',...
                'position',[pos(1) pos(2) 580 30*LENGTH+180],...
                'color',COLOR,...
                'menubar','none',...
                'numbertitle','off',...
                'name','Greeks');
  clf;
  drawnow;

  m=size(OLD,1);
  LINE=zeros(LENGTH,1);
  POSITION=zeros(LENGTH,5);
  for i=1:m,
    y=30*(LENGTH+1-i);
    LINE(i)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','checkbox',...
                      'position',[40 y 20 20]);
    set(LINE(i),'value',OLD(i,6));
    POSITION(i,1)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[110 y 40 20],...
                            'string',num2str(OLD(i,1)));
    POSITION(i,2)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
                            'position',[170 y 90 20],...
                            'string','LONG|SHORT');
    set(POSITION(i,2),'value',OLD(i,2));
    POSITION(i,3)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[280 y 40 20],...
                            'string',num2str(OLD(i,3)));
    POSITION(i,4)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
                            'position',[340 y 90 20],...
                            'string','CALL|PUT|FUTURES');
    set(POSITION(i,4),'value',OLD(i,4));
    POSITION(i,5)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[500 y 40 20],...
                            'string',num2str(OLD(i,5)));
  end
  for i=(m+1):LENGTH,
    y=30*(LENGTH+1-i);
    LINE(i)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','checkbox',...
                      'position',[40 y 20 20]);  
    POSITION(i,1)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[110 y 40 20],...
                            'string','1');
    POSITION(i,2)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
                            'position',[170 y 90 20],...
                            'string','LONG|SHORT'); 
    POSITION(i,3)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[280 y 40 20],...
                            'string','500'); 
    POSITION(i,4)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
                            'position',[340 y 90 20],...
                            'string','CALL|PUT|FUTURES'); 
    POSITION(i,5)=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                            'position',[500 y 40 20],...
                            'string','10');
  end
  y=30*LENGTH;

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[40 y+130 120 20],...
            'string','PARAMETERS');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 y+90 50 20],...
            'string','r=');
  R=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[110 y+90 40 20],...
              'string',num2str(OLD2(1)));
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 y+70 50 20],...
            'string','v=');
  V=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[110 y+70 40 20],...
              'string',num2str(OLD2(2)));
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[50 y+50 50 20],...
            'string','lines=');
  L=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
              'position',[110 y+50 40 20],...
              'string',num2str(LENGTH),...
              'callback','part2(''length'')');

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[180 y+130 120 20],...
            'string','RANGE');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[190 y+90 50 20],...
            'string','min=');
  MIN=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                'position',[250 y+90 40 20],...
                'string',num2str(OLD2(3)));
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[190 y+70 50 20],...
            'string','max=');
  MAX=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','edit',...
                'position',[250 y+70 40 20],...
                'string',num2str(OLD2(4)));

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','text',...
            'position',[320 y+130 120 20],...
            'string','INDICATOR');
  TYPE=uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','popupmenu',...
                 'position',[330 y+90 100 20],...
                 'string','DELTA|GAMMA|THETA|VEGA|RHO',...
                 'value',OLD2(5));

  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[470 y+130 70 20],...
            'string','MESH',...
            'callback','part2(''mesh'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[470 y+90 70 20],...
            'string','HELP',...
            'callback','part2(''help'')');
  uicontrol('backgroundcolor',[0.753 0.753 0.753],'style','pushbutton',...
            'position',[470 y+50 70 20],...
            'string','EXIT',...
            'callback','part2(''exit'')');

elseif strcmp(action,'length')
  l=str2num(get(L,'string'));
  screen=get(0,'screensize');
  if 1<=l & l<=floor((screen(4)-210)/30)
    m=min(LENGTH,l);
    OLD=zeros(m,7);
    for i=1:m,
      OLD(i,1)=str2num(get(POSITION(i,1),'string'));
      OLD(i,2)=get(POSITION(i,2),'value');
      OLD(i,3)=str2num(get(POSITION(i,3),'string'));
      OLD(i,4)=get(POSITION(i,4),'value');
      OLD(i,5)=str2num(get(POSITION(i,5),'string'));
      OLD(i,6)=get(LINE(i),'value');      
    end
    OLD2(1)=str2num(get(R,'string'));
    OLD2(2)=str2num(get(V,'string'));
    OLD2(3)=str2num(get(MIN,'string'));
    OLD2(4)=str2num(get(MAX,'string'));
    OLD2(5)=get(TYPE,'value');
    LENGTH=l;
    part2('init');
  else
    disp('Sorry, to many lines');
  end

elseif strcmp(action,'mesh')
  row=1;
  for i=1:LENGTH,
    if get(LINE(i),'value')
      p(row,1)=str2num(get(POSITION(i,1),'string'));
      if get(POSITION(i,2),'value')==1
        p(row,2)=-1;
      else
        p(row,2)=1;
      end
      p(row,3)=str2num(get(POSITION(i,3),'string'));
      if get(POSITION(i,4),'value')==1
        p(row,4)=1;
      elseif get(POSITION(i,4),'value')==2
        p(row,4)=-1;
      else
        p(row,4)=0;
      end
      p(row,5)=str2num(get(POSITION(i,5),'string'));
      row=row+1;
    end
  end
  if row>1
    FIGURE=switch(FIGURE,2);
    set(FIGURE(2),'numbertitle','off',...
                  'name','Indicator');
    clf;
    minp=str2num(get(MIN,'string'));
    maxp=str2num(get(MAX,'string'));
    r=str2num(get(R,'string'));
    v=str2num(get(V,'string'));
    str=get(TYPE,'string');
    type=deblank(str(get(TYPE,'value'),:));
    greek3(p,r,v,type,minp,maxp);
  end

elseif strcmp(action,'help')
  page1=...
    ['r, v                                                  '
     '  annual interest rate/volatility (in percent);       '
     'lines                                                 '
     '  number of lines used to define the position;        '
     'Below in columns:                                     '
     '  - selection of active lines;                        '
     '  - number of contracts;                              '
     '  - LONG/SHORT position;                              '
     '  - strike price;                                     '
     '  - type of contract: CALL, PUT, FUTURES;             '
     '  - time to maturity (in days);                       '
     'min, max                                              '
     '  range of prices on the plot;                        '
     'INDICATOR                                             '
     '  select: delta, gamma, theta, vega or rho;           '
     'MESH                                                  '
     '  3D payout profile in the Black model;               '
     'HELP                                                  '
     '  this help window;                                   '
     'EXIT                                                  '
     '  return to FINDEMO;                                  '];

  page2=...
    ['r, v                                                  '
     '  roczna stopa procentowa/zmiennosc (w procentach);   '
     'lines                                                 '
     '  liczba linii edycyjnych;                            '
     'Ponizej w kolumnach:                                  '
     '  - zaznaczenie aktywnych linii edycyjnych;           '
     '  - liczba kontraktow;                                '
     '  - dluga/krotka pozycja;                             '
     '  - cena wykonania kontraktu;                         '
     '  - typ kontraktu: opcja kupna lub sprzedazy, futures;'
     '  - czas do wygasniecia, podany w dniach;             '
     'min, max                                              '
     '  zakres cen instrumentu podstawowego na wykresie;    '
     'INDICATOR                                             '
     '  rodzaj wskaznika: delta, gamma, theta, vega lub rho;'
     'MESH                                                  '
     '  3D wykres pozycji w modelu Blacka;                  '
     'HELP                                                  '
     '  pomoc;                                              '
     'EXIT                                                  '
     '  powrot do FINDEMO;                                  '];

  buttonStr=['English';
             'Polski ';
             '       '];
  helpfn('Greeks',buttonStr,page1,page2);
  pos=get(gcf,'position');
  set(gcf,'name','Help',...
    'position',[pos(1) pos(2) 460 340],...
    'resize','off',...
    'menubar','none');


elseif strcmp(action,'exit')
  list=get(0,'children');
  for i=1:length(list),
    if list(i)~=FIGURE(5)
      close(list(i));
    end
  end
  set(FIGURE(5),'visible','on');
  clear global LENGTH OLD OLD2 LINE POSITION L R V MIN MAX TYPE;
end

