function v=posvalue(S,nocontracts,shortlong,strike,contract,premium)
%POSVALUE Internally used by POSITION.

% Copyright (c) 1996-98 by Rafal Weron.
% Written by: K. Rojek, R. Seredynski, R. Weron.

ret=[];
delta=strike-S;
for i=1:length(strike),
  % short contract
  if shortlong(i)==1,
    if contract(i)==0, % Underlying
      ret(i)=delta(i);
    end;
    if contract(i)==1 % Call
      if delta(i)>=0, ret(i)=premium(i); end;
      if delta(i)<0, ret(i)=premium(i)-abs(delta(i)); end;
    end;
    if contract(i)==-1 % Put
      if delta(i)>0, ret(i)=premium(i)-abs(delta(i)); end;
      if delta(i)<=0, ret(i)=premium(i); end;
    end;
  end;
  % long contract
  if shortlong(i)==-1,
    if contract(i)==0, % Underlying
      ret(i)=-delta(i);
    end;
    if contract(i)==1, % Call
      if delta(i)>=0, ret(i)=-premium(i); end;
      if delta(i)<0, ret(i)=abs(delta(i))-premium(i); end;
    end;
    if contract(i)==-1, % Put
      if delta(i)>0, ret(i)=abs(delta(i))-premium(i); end;
      if delta(i)<=0, ret(i)=-premium(i); end;
    end;
  end;
end;

v=sum(ret.*nocontracts);
